// $Id$

//=============================================================================
/**
 *  @file  state_task.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_STATE_TASK_H
#define JYUGEM_BEE_STATE_TASK_H

#include "jyugem/bee/task.h"

namespace jyugem { namespace bee
{

// Forword declaration
class state_machine_task_base;


//------------------------------------------------------------------------------
//
// Service task base class
//
//------------------------------------------------------------------------------
class BEE_Export state_task : public task
{
public:
  state_task(const string& name, state_machine_task_base * machine = null)
    : task(name), m_status(machine) {}
  state_task(const state_task& rhs) : task(rhs), m_status(rhs.m_status) {}
  virtual ~state_task() {}

  state_task& operator=(const state_task& rhs)
  {
    if (this == &rhs)
      return *this;
    this->task::operator=(rhs);
    return *this;
  }

  int update(const std::string& evtname);

  template<class T>
  T * cast_status()
  {
    T * result = null;
    try
    {
      result = dynamic_cast<T *>(m_status);
    }
    catch (const std::bad_cast& ex)
    {
      TRACE_ERROR((_TX("Failure status cast: %s\n"), ex.what()));
    }
    return result;
  }

protected:

  virtual int svc(void);

// member variables
protected:
  state_machine_task_base * m_status;

};

} } // *namespace* jyugem::bee

#endif  /* JYUGEM_BEE_STATE_TASK_H */
