// $Id$

//=============================================================================
/**
 *  @file    ControlJobManager.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================
#ifndef JYUGEM_CJM_CONTROLJOBMANAGER_H
#define JYUGEM_CJM_CONTROLJOBMANAGER_H


#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif

#include <ctime>
#include <iostream>
#include <string>

#include "jyugem/bee/task.h"
namespace bee = jyugem::bee;


//
namespace jyugem { namespace cjm
{

//
// E94 : PROVISIONAL SPECIFICATION FOR CONTROL JOB MANAGEMENT
//

#define CJCreate    // Created by S14F1 that E39 define.
#define CJStart
#define CJPause
#define CJResume
#define CJCancel
#define CJDeselect
#define CJStop
#define CJAbort
#define CJHOQ


class ControlJobManager : gem::job_manager<ControlJob>
{
    friend class ControlJob;

public:
    //typedef std::map<std::string, ControlJob *, std::less<std::string> >
    //    Jobs;

    ControlJobManager() : bee::job_manager<ControlJob>("ControlJob") {}
    virtual ~ControlJobManager() {}

    virtual int notify(bee::trigger * trig, bee::task * tsk);

//
protected:

};


} }  // *namespace* jyugem::cjm

#endif  /* JYUGEM_CJM_CONTROLJOBMANAGER_H */

