// $Id$

//=============================================================================
/**
 *  @file    CarrierHandler.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_CMS_CARRIERHANDLER_H
#define JYUGEM_CMS_CARRIERHANDLER_H

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif


#include "jyugem/bee/state_task.h"
namespace bee = jyugem::bee;


//
namespace jyugem { namespace cms
{

class LoadPort;
typedef boost::shared_ptr<LoadPort> LoadPortPtr;

//-----------------------------------------------------------------------------
//
// E87 : SPECIFICATION FOR CARRIER MANAGEMENT
//
//       Carier Handler class
//
//-----------------------------------------------------------------------------
class CarrierHandler
{
  friend class LoadPort;
  friend class LoadPortGroup;

public:

  CarrierHandler();
// CarrierHandler(const CarrierHandler& rhs) { this->copy(rhs); }
  virtual ~CarrierHandler() {}

// CarrierHandler& operator=(const CarrierHandler& rhs)
// {
//   if ( this== &rhs)
//     return *this;
//   this->copy(rhs);
//   return *this;
// }

  int open();

  LoadPortGroup * group(int gnum)
  {
    if (gnum > (int)m_ports.size() || gnum <= 0)
      return null;
    return m_groups[gnum - 1];
  }


  LoadPortPtr loadport(int pnum)
  {
    if (pnum > (int)m_ports.size() || pnum <= 0)
      return LoadPortPtr();
    return m_ports[pnum - 1];
  }

protected:
//  void copy(const CarrierHandler& rhs);

protected:
    std::vector<LoadPortGroup *> m_groups;
    std::vector<LoadPortPtr>     m_ports;
};

} } // *namespace* jyugem::cms

#endif
