// $Id$

//=============================================================================
/**
 *  @file    LoadPortGroup.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_CMS_LOADPORTGROUP_H
#define JYUGEM_CMS_LOADPORTGROUP_H

#ifdef _MSC_VER
#pragma warning( disable: 4267 )
#endif


#include <boost/mpl/list.hpp>
#include <boost/format.hpp>

#include "jyugem/bee/state_task.h"
namespace bee = jyugem::bee;


//
namespace jyugem { namespace cms
{

//-----------------------------------------------------------------------------
//
// E87 : SPECIFICATION FOR CARRIER MANAGEMENT
//
//       Load Port Group class
//
//-----------------------------------------------------------------------------
class LoadPortGroup
{
public:
    LoadPortGroup(const std::string& name);
//  LoadPortGroup(const LoadPortGroup& rhs) { this->copy(rhs); }
    virtual ~LoadPortGroup() {}

//  LoadPortGroup& operator=(const LoadPortGroup& rhs)
//  {
//      if ( this== &rhs)
//          return *this;
//      this->copy(rhs);
//      return *this;
//  }

    std::string name()       { return m_name; }
    std::vector<int> ports() { return m_loadports; }

protected:
//  void copy(const LoadPortGroup& rhs);

protected:
    std::string        m_name;
    std::vector<int>   m_loadports;
};

} } // *namespace* jyugem::cms

#endif  // JYUGEM_CMS_LOADPORTGROUP_H
