// $Id$

//=============================================================================
/**
 *  @file    CIDRWClass.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL


#include <boost/python/suite/indexing/vector_indexing_suite.hpp>
#include <boost/python/module.hpp>
#include <boost/python/def.hpp>
#include <boost/python/implicit.hpp>
#include <boost/python/class.hpp>
#include <boost/python/enum.hpp>
#include <boost/python/overloads.hpp>

#include "jyugem/bee.h"
#include "jyugem/cidrw/cidrw.h"

using namespace jyugem::cidrw;
using namespace boost::python;

namespace jyugem { namespace cidrw
{

struct cidrw_wrapper
{
  static void wrap()
  {
    class_< CIDRW >("CIDRW")
      .def_readwrite("AlarmStatus",       &CIDRW::m_alarmStatus)
      .def_readwrite("OperationalStatus", &CIDRW::m_operationalStatus)
      .def_readwrite("Installed",         &CIDRW::m_installed)
      .def_readwrite("Configuration",     &CIDRW::m_Configuration)
      .def_readwrite("DeviceType",        &CIDRW::m_DeviceType)
      .def_readwrite("SoftwareRevisionLevel", &CIDRW::m_SoftwareRevisionLevel)
      .def_readwrite("HardwareRevisionLevel", &CIDRW::m_HardwareRevisionLevel)
      .def_readwrite("MaintenanceData", &CIDRW::m_MaintenanceData)
      .def_readwrite("Manufacturer",    &CIDRW::m_Manufacturer)
      .def_readwrite("ModelNumber",     &CIDRW::m_ModelNumber)
      .def_readwrite("SerialNumber",    &CIDRW::m_SerialNumber)
      .def("open",          &CIDRW::open0)
      .def("update",        &CIDRW::update)
      .def("current_state", &CIDRW::current_state)
      .def("update_head", &CIDRW::update_head)
      .def("head_state",  &CIDRW::head_state)
      ;
  }
};

//
//
//
void init_module()
{
  cidrw_wrapper::wrap();
}

} } // *namespace* jyugem::cidrw

BOOST_PYTHON_MODULE(cidrw)
{
  jyugem::cidrw::init_module();
}
